Rewording for "make an intervention".
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
49114fd4 5## Copyright (C) 2001-2011 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Override this in cfg.mk if you use a non-standard build-aux directory.
25build_aux ?= $(srcdir)/build-aux
26
27# Do not save the original name or timestamp in the .tar.gz file.
28# Use --rsyncable if available.
29gzip_rsyncable := \
a927b6c1
LC
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
c84bdaf6
LC
32GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
c84bdaf6
LC
34GIT = git
35VC = $(GIT)
36VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37
38VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
61cd9dc9
LC
40# You can override this variable in cfg.mk to set your own regexp
41# matching files to ignore.
42VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43
44# This is to preprocess robustly the output of $(VC_LIST), so that even
45# when $(srcdir) is a pathological name like "....", the leading sed command
46# removes only the intended prefix.
47_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48
49# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50# when $(srcdir) is not ".".
51ifeq ($(srcdir),.)
52_prepend_srcdir_prefix =
53else
54_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55endif
56
57# In order to be able to consistently filter "."-relative names,
58# (i.e., with no $(srcdir) prefix), this definition is careful to
59# remove any $(srcdir) prefix, and to restore what it removes.
c84bdaf6 60VC_LIST_EXCEPT = \
61cd9dc9
LC
61 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
62 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
63 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
64 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
65 $(_prepend_srcdir_prefix)
c84bdaf6
LC
66
67ifeq ($(origin prev_version_file), undefined)
68 prev_version_file = $(srcdir)/.prev-version
69endif
70
71PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
72VERSION_REGEXP = $(subst .,\.,$(VERSION))
73PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
74
75ifeq ($(VC),$(GIT))
76this-vc-tag = v$(VERSION)
77this-vc-tag-regexp = v$(VERSION_REGEXP)
78else
79tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
80tag-this-version = $(subst .,_,$(VERSION))
81this-vc-tag = $(tag-package)-$(tag-this-version)
82this-vc-tag-regexp = $(this-vc-tag)
83endif
84my_distdir = $(PACKAGE)-$(VERSION)
85
86# Old releases are stored here.
87release_archive_dir ?= ../release
88
414e4441
LC
89# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
90# Use alpha.gnu.org for alpha and beta releases.
91# Use ftp.gnu.org for stable releases.
92gnu_ftp_host-alpha = alpha.gnu.org
93gnu_ftp_host-beta = alpha.gnu.org
94gnu_ftp_host-stable = ftp.gnu.org
95gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
96
97ifeq ($(gnu_rel_host),ftp.gnu.org)
98url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
99else
100url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
101endif
102
1cd4fffc
LC
103# Override this in cfg.mk if you are using a different format in your
104# NEWS file.
105today = $(shell date +%Y-%m-%d)
9157d901
LC
106
107# Select which lines of NEWS are searched for $(news-check-regexp).
108# This is a sed line number spec. The default says that we search
109# lines 1..10 of NEWS for $(news-check-regexp).
110# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
111news-check-lines-spec ?= 1,10
1cd4fffc
LC
112news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
113
c84bdaf6
LC
114# Prevent programs like 'sort' from considering distinct strings to be equal.
115# Doing it here saves us from having to set LC_ALL elsewhere in this file.
116export LC_ALL = C
117
118## --------------- ##
119## Sanity checks. ##
120## --------------- ##
121
122_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
123
124# Collect the names of rules starting with `sc_'.
125syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
126 $(srcdir)/$(ME) $(_cfg_mk)))
127.PHONY: $(syntax-check-rules)
128
129local-checks-available = \
130 $(syntax-check-rules)
131.PHONY: $(local-checks-available)
132
133# Arrange to print the name of each syntax-checking rule just before running it.
134$(syntax-check-rules): %: %.m
dde9c5a4
LC
135sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
136.PHONY: $(sc_m_rules_)
137$(sc_m_rules_):
c84bdaf6 138 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
139 @date +%s.%N > .sc-start-$(basename $@)
140
141# Compute and print the elapsed time for each syntax-check rule.
142sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
143.PHONY: $(sc_z_rules_)
144$(sc_z_rules_): %.z: %
145 @end=$$(date +%s.%N); \
146 start=$$(cat .sc-start-$*); \
147 rm -f .sc-start-$*; \
148 awk -v s=$$start -v e=$$end \
149 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
150
151# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
152# that computes and prints elapsed time.
153local-check := \
154 $(patsubst sc_%, sc_%.z, \
155 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
156
157syntax-check: $(local-check)
a927b6c1
LC
158
159# _sc_search_regexp
160#
161# This macro searches for a given construct in the selected files and
162# then takes some action.
163#
164# Parameters (shell variables):
165#
166# prohibit | require
167#
168# Regular expression (ERE) denoting either a forbidden construct
169# or a required construct. Those arguments are exclusive.
170#
171# in_vc_files | in_files
172#
173# grep-E-style regexp denoting the files to check. If no files
174# are specified the default are all the files that are under
175# version control.
176#
177# containing | non_containing
178#
179# Select the files (non) containing strings matching this regexp.
180# If both arguments are specified then CONTAINING takes
181# precedence.
182#
183# with_grep_options
184#
185# Extra options for grep.
186#
187# ignore_case
188#
189# Ignore case.
190#
191# halt
192#
193# Message to display before to halting execution.
194
195# By default, _sc_search_regexp does not ignore case.
c84bdaf6 196export ignore_case =
a927b6c1 197_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 198
a927b6c1
LC
199define _sc_say_and_exit
200 dummy=; : so we do not need a semicolon before each use; \
201 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
202endef
203
204# _sc_search_regexp used to be named _prohibit_regexp. However,
205# upgrading to the new definition and leaving the old name undefined
206# would usually convert each custom rule using $(_prohibit_regexp)
207# (usually defined in cfg.mk) into a no-op. This definition ensures
208# that people know right away if they're still using the old name.
209# FIXME: remove in 2012.
210_prohibit_regexp = \
211 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
212
213define _sc_search_regexp
214 dummy=; : so we do not need a semicolon before each use; \
215 \
216 : Check arguments; \
217 test -n "$$prohibit" && test -n "$$require" \
218 && { msg='Cannot specify both prohibit and require' \
219 $(_sc_say_and_exit) } || :; \
220 test -z "$$prohibit" && test -z "$$require" \
221 && { msg='Should specify either prohibit or require' \
222 $(_sc_say_and_exit) } || :; \
223 test -n "$$in_vc_files" && test -n "$$in_files" \
224 && { msg='Cannot specify both in_vc_files and in_files' \
225 $(_sc_say_and_exit) } || :; \
226 test "x$$halt" != x \
227 || { msg='halt not defined' $(_sc_say_and_exit) }; \
228 \
229 : Filter by file name; \
230 if test -n "$$in_files"; then \
231 files=$$(find $(srcdir) | grep -E "$$in_files"); \
232 else \
233 files=$$($(VC_LIST_EXCEPT)); \
234 if test -n "$$in_vc_files"; then \
235 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
236 fi; \
237 fi; \
238 \
239 : Filter by content; \
240 test -n "$$files" && test -n "$$containing" \
241 && { files=$$(grep -l "$$containing" $$files); } || :; \
242 test -n "$$files" && test -n "$$non_containing" \
243 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
244 \
245 : Check for the construct; \
246 if test -n "$$files"; then \
247 if test -n "$$prohibit"; then \
248 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
249 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
250 else \
251 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
252 | grep . \
253 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
254 fi \
255 else :; \
256 fi || :;
c84bdaf6
LC
257endef
258
259sc_avoid_if_before_free:
260 @$(build_aux)/useless-if-before-free \
261 $(useless_free_options) \
262 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
263 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
264 exit 1; } || :
265
266sc_cast_of_argument_to_free:
a927b6c1
LC
267 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
268 $(_sc_search_regexp)
c84bdaf6
LC
269
270sc_cast_of_x_alloc_return_value:
a927b6c1
LC
271 @prohibit='\*\) *x(m|c|re)alloc\>' \
272 halt='don'\''t cast x*alloc return value' \
273 $(_sc_search_regexp)
c84bdaf6
LC
274
275sc_cast_of_alloca_return_value:
a927b6c1
LC
276 @prohibit='\*\) *alloca\>' \
277 halt='don'\''t cast alloca return value' \
278 $(_sc_search_regexp)
c84bdaf6
LC
279
280sc_space_tab:
a927b6c1
LC
281 @prohibit='[ ] ' \
282 halt='found SPACE-TAB sequence; remove the SPACE' \
283 $(_sc_search_regexp)
c84bdaf6
LC
284
285# Don't use *scanf or the old ato* functions in `real' code.
286# They provide no error checking mechanism.
287# Instead, use strto* functions.
288sc_prohibit_atoi_atof:
a927b6c1
LC
289 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
290 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
291 $(_sc_search_regexp)
c84bdaf6
LC
292
293# Use STREQ rather than comparing strcmp == 0, or != 0.
294sc_prohibit_strcmp:
49114fd4 295 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
c84bdaf6 296 $$($(VC_LIST_EXCEPT)) \
49114fd4
LC
297 | grep -vE ':# *define STRN?EQ\(' && \
298 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
c84bdaf6
LC
299 1>&2; exit 1; } || :
300
301# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
302# Convert all uses automatically, via these two commands:
303# git grep -l '\<exit *(1)' \
304# | grep -vEf .x-sc_prohibit_magic_number_exit \
305# | xargs --no-run-if-empty \
306# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
307# git grep -l '\<exit *(0)' \
308# | grep -vEf .x-sc_prohibit_magic_number_exit \
309# | xargs --no-run-if-empty \
310# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 311sc_prohibit_magic_number_exit:
a927b6c1
LC
312 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
313 halt='use EXIT_* values rather than magic number' \
314 $(_sc_search_regexp)
c84bdaf6
LC
315
316# Using EXIT_SUCCESS as the first argument to error is misleading,
317# since when that parameter is 0, error does not exit. Use `0' instead.
318sc_error_exit_success:
a927b6c1
LC
319 @prohibit='error *\(EXIT_SUCCESS,' \
320 in_vc_files='\.[chly]$$' \
321 halt='found error (EXIT_SUCCESS' \
322 $(_sc_search_regexp)
c84bdaf6
LC
323
324# `FATAL:' should be fully upper-cased in error messages
325# `WARNING:' should be fully upper-cased, or fully lower-cased
326sc_error_message_warn_fatal:
a927b6c1 327 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
328 | grep -E '"Warning|"Fatal|"fatal' && \
329 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
330 exit 1; } || :
331
332# Error messages should not start with a capital letter
333sc_error_message_uppercase:
a927b6c1 334 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
335 | grep -E '"[A-Z]' \
336 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
337 { echo '$(ME): found capitalized error message' 1>&2; \
338 exit 1; } || :
339
340# Error messages should not end with a period
341sc_error_message_period:
a927b6c1 342 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
343 | grep -E '[^."]\."' && \
344 { echo '$(ME): found error message ending in period' 1>&2; \
345 exit 1; } || :
346
347sc_file_system:
a927b6c1
LC
348 @prohibit=file''system \
349 ignore_case=1 \
350 halt='found use of "file''system"; spell it "file system"' \
351 $(_sc_search_regexp)
c84bdaf6
LC
352
353# Don't use cpp tests of this symbol. All code assumes config.h is included.
354sc_prohibit_have_config_h:
a927b6c1
LC
355 @prohibit='^# *if.*HAVE''_CONFIG_H' \
356 halt='found use of HAVE''_CONFIG_H; remove' \
357 $(_sc_search_regexp)
c84bdaf6
LC
358
359# Nearly all .c files must include <config.h>. However, we also permit this
360# via inclusion of a package-specific header, if cfg.mk specified one.
361# config_h_header must be suitable for grep -E.
362config_h_header ?= <config\.h>
363sc_require_config_h:
a927b6c1
LC
364 @require='^# *include $(config_h_header)' \
365 in_vc_files='\.c$$' \
366 halt='the above files do not include <config.h>' \
367 $(_sc_search_regexp)
c84bdaf6
LC
368
369# You must include <config.h> before including any other header file.
370# This can possibly be via a package-specific header, if given by cfg.mk.
371sc_require_config_h_first:
372 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
373 fail=0; \
374 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
375 grep '^# *include\>' $$i | sed 1q \
376 | grep -E '^# *include $(config_h_header)' > /dev/null \
377 || { echo $$i; fail=1; }; \
378 done; \
379 test $$fail = 1 && \
380 { echo '$(ME): the above files include some other header' \
381 'before <config.h>' 1>&2; exit 1; } || :; \
382 else :; \
383 fi
384
385sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
386 @prohibit='\bHAVE_MBRTOWC\b' \
387 halt="do not use $$prohibit; it is always defined" \
388 $(_sc_search_regexp)
c84bdaf6
LC
389
390# To use this "command" macro, you must first define two shell variables:
391# h: the header, enclosed in <> or ""
392# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 393define _sc_header_without_use
c84bdaf6
LC
394 dummy=; : so we do not need a semicolon before each use; \
395 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
396 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
397 files=$$(grep -l '^# *include '"$$h_esc" \
398 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
399 grep -LE "$$re" $$files | grep . && \
400 { echo "$(ME): the above files include $$h but don't use it" \
401 1>&2; exit 1; } || :; \
402 else :; \
403 fi
404endef
405
406# Prohibit the inclusion of assert.h without an actual use of assert.
407sc_prohibit_assert_without_use:
a927b6c1 408 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
409
410# Prohibit the inclusion of close-stream.h without an actual use.
411sc_prohibit_close_stream_without_use:
a927b6c1 412 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
413
414# Prohibit the inclusion of getopt.h without an actual use.
415sc_prohibit_getopt_without_use:
a927b6c1 416 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
417
418# Don't include quotearg.h unless you use one of its functions.
419sc_prohibit_quotearg_without_use:
a927b6c1 420 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
421
422# Don't include quote.h unless you use one of its functions.
423sc_prohibit_quote_without_use:
a927b6c1 424 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
425
426# Don't include this header unless you use one of its functions.
427sc_prohibit_long_options_without_use:
428 @h='"long-options.h"' re='\<parse_long_options *\(' \
a927b6c1 429 $(_sc_header_without_use)
c84bdaf6
LC
430
431# Don't include this header unless you use one of its functions.
432sc_prohibit_inttostr_without_use:
433 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 434 $(_sc_header_without_use)
c84bdaf6 435
61cd9dc9
LC
436# Don't include this header unless you use one of its functions.
437sc_prohibit_ignore_value_without_use:
438 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
a927b6c1 439 $(_sc_header_without_use)
61cd9dc9 440
c84bdaf6
LC
441# Don't include this header unless you use one of its functions.
442sc_prohibit_error_without_use:
443 @h='"error.h"' \
444 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 445 $(_sc_header_without_use)
c84bdaf6
LC
446
447# Don't include xalloc.h unless you use one of its functions.
448# Consider these symbols:
449# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 450# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
451# Divide into two sets on case, and filter each through this:
452# | sort | perl -MRegexp::Assemble -le \
453# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
454# Note this was produced by the above:
61cd9dc9
LC
455# _xa1 = \
456#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
457# But we can do better, in at least two ways:
458# 1) take advantage of two "dup"-suffixed strings:
459# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
460# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
461# "char|[cmz]"
462# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
463_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
464_xa2 = X([CZ]|N?M)ALLOC
465sc_prohibit_xalloc_without_use:
466 @h='"xalloc.h"' \
467 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 468 $(_sc_header_without_use)
c84bdaf6 469
dde9c5a4 470# Extract function names:
a927b6c1 471# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
472_hash_re = \
473clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
474_hash_fn = \<($(_hash_re)) *\(
475_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
476sc_prohibit_hash_without_use:
477 @h='"hash.h"' \
478 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 479 $(_sc_header_without_use)
dde9c5a4
LC
480
481sc_prohibit_hash_pjw_without_use:
482 @h='"hash-pjw.h"' \
483 re='\<hash_pjw *\(' \
a927b6c1 484 $(_sc_header_without_use)
dde9c5a4 485
c84bdaf6
LC
486sc_prohibit_safe_read_without_use:
487 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 488 $(_sc_header_without_use)
c84bdaf6
LC
489
490sc_prohibit_argmatch_without_use:
491 @h='"argmatch.h"' \
492 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
a927b6c1 493 $(_sc_header_without_use)
c84bdaf6
LC
494
495sc_prohibit_canonicalize_without_use:
496 @h='"canonicalize.h"' \
497 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
a927b6c1 498 $(_sc_header_without_use)
c84bdaf6
LC
499
500sc_prohibit_root_dev_ino_without_use:
501 @h='"root-dev-ino.h"' \
502 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 503 $(_sc_header_without_use)
c84bdaf6
LC
504
505sc_prohibit_openat_without_use:
506 @h='"openat.h"' \
507 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 508 $(_sc_header_without_use)
c84bdaf6
LC
509
510# Prohibit the inclusion of c-ctype.h without an actual use.
511ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
512|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
513sc_prohibit_c_ctype_without_use:
a927b6c1
LC
514 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
515 $(_sc_header_without_use)
c84bdaf6
LC
516
517_empty =
518_sp = $(_empty) $(_empty)
519# The following list was generated by running:
520# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
521# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
522_sig_functions = \
523 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
524 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
525 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
526 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
527_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
528# The following were extracted from "man signal.h" manually.
529_sig_types_and_consts = \
530 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
531 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
532 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
533 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
534 sigstack sigval stack_t ucontext_t
535# generated via this:
536# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
537_sig_names = \
538 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
539 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
540 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
541 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
542 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
543 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
544 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
545 SIGXCPU SIGXFSZ
546_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
547
548# Prohibit the inclusion of signal.h without an actual use.
549sc_prohibit_signal_without_use:
550 @h='<signal.h>' \
551 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
552 $(_sc_header_without_use)
553
554# Prohibit the inclusion of strings.h without a sensible use.
555# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
556sc_prohibit_strings_without_use:
557 @h='<strings.h>' \
558 re='\<(strn?casecmp|ffs(ll)?)\>' \
559 $(_sc_header_without_use)
560
561# Get the list of symbol names with this:
562# perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
563_intprops_names = \
564 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
565 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
566 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
567_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
568# Prohibit the inclusion of intprops.h without an actual use.
569sc_prohibit_intprops_without_use:
570 @h='"intprops.h"' \
571 re='\<($(_intprops_syms_re)) *\(' \
572 $(_sc_header_without_use)
c84bdaf6 573
49114fd4
LC
574_stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
575# Prohibit the inclusion of stddef.h without an actual use.
576sc_prohibit_stddef_without_use:
577 @h='<stddef.h>' \
578 re='\<($(_stddef_syms_re)) *\(' \
579 $(_sc_header_without_use)
580
c84bdaf6 581sc_obsolete_symbols:
a927b6c1
LC
582 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
583 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
584 $(_sc_search_regexp)
c84bdaf6
LC
585
586# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
587
588# Each nonempty ChangeLog line must start with a year number, or a TAB.
589sc_changelog:
a927b6c1
LC
590 @prohibit='^[^12 ]' \
591 in_vc_files='^ChangeLog$$' \
592 halt='found unexpected prefix in a ChangeLog' \
593 $(_sc_search_regexp)
c84bdaf6
LC
594
595# Ensure that each .c file containing a "main" function also
596# calls set_program_name.
597sc_program_name:
a927b6c1
LC
598 @require='set_program_name *\(m?argv\[0\]\);' \
599 in_vc_files='\.c$$' \
0f00f2c3 600 containing='\<main *(' \
a927b6c1
LC
601 halt='the above files do not call set_program_name' \
602 $(_sc_search_regexp)
c84bdaf6 603
0f00f2c3
LC
604# Ensure that each .c file containing a "main" function also
605# calls bindtextdomain.
606sc_bindtextdomain:
607 @require='bindtextdomain *\(' \
608 in_vc_files='\.c$$' \
609 containing='\<main *(' \
610 halt='the above files do not call bindtextdomain' \
611 $(_sc_search_regexp)
612
c84bdaf6
LC
613# Require that the final line of each test-lib.sh-using test be this one:
614# Exit $fail
615# Note: this test requires GNU grep's --label= option.
616Exit_witness_file ?= tests/test-lib.sh
617Exit_base := $(notdir $(Exit_witness_file))
618sc_require_test_exit_idiom:
619 @if test -f $(srcdir)/$(Exit_witness_file); then \
620 die=0; \
621 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
622 $$($(VC_LIST) tests)); do \
623 tail -n1 $$i | grep '^Exit .' > /dev/null \
624 && : || { die=1; echo $$i; } \
625 done; \
626 test $$die = 1 && \
627 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
628 echo 1>&2 'Exit something'; \
629 exit 1; } || :; \
630 fi
631
632sc_the_the:
a927b6c1
LC
633 @prohibit='\<the ''the\>' \
634 ignore_case=1 \
635 halt='found use of "the ''the";' \
636 $(_sc_search_regexp)
c84bdaf6
LC
637
638sc_trailing_blank:
a927b6c1
LC
639 @prohibit='[ ]$$' \
640 halt='found trailing blank(s)' \
641 $(_sc_search_regexp)
c84bdaf6
LC
642
643# Match lines like the following, but where there is only one space
644# between the options and the description:
645# -D, --all-repeated[=delimit-method] print all duplicate lines\n
646longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
647sc_two_space_separator_in_usage:
a927b6c1
LC
648 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
649 halt='help2man requires at least two spaces between an option and its description'\
650 $(_sc_search_regexp)
c84bdaf6
LC
651
652# Look for diagnostics that aren't marked for translation.
653# This won't find any for which error's format string is on a separate line.
654sc_unmarked_diagnostics:
655 @grep -nE \
a927b6c1 656 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
657 | grep -v '_''(' && \
658 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
659 exit 1; } || :
660
661# Avoid useless parentheses like those in this example:
662# #if defined (SYMBOL) || defined (SYM2)
663sc_useless_cpp_parens:
a927b6c1
LC
664 @prohibit='^# *if .*defined *\(' \
665 halt='found useless parentheses in cpp directive' \
666 $(_sc_search_regexp)
667
668# List headers for which HAVE_HEADER_H is always true, assuming you are
669# using the appropriate gnulib module. CAUTION: for each "unnecessary"
670# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
671# requires the gnulib module that guarantees the usability of that header.
672gl_assured_headers_ = \
673 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
674
675# Convert the list of names to upper case, and replace each space with "|".
676az_ = abcdefghijklmnopqrstuvwxyz
677AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
678gl_header_upper_case_or_ = \
679 $$($(gl_assured_headers_) \
680 | tr $(az_)/.- $(AZ_)___ \
681 | tr -s ' ' '|' \
682 )
683sc_prohibit_always_true_header_tests:
684 @or=$(gl_header_upper_case_or_); \
685 re="HAVE_($$or)_H"; \
686 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
687 halt=$$(printf '%s\n' \
688 'do not test the above HAVE_<header>_H symbol(s);' \
689 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
690 $(_sc_search_regexp)
691
692# ==================================================================
693gl_other_headers_ ?= \
694 intprops.h \
695 openat.h \
696 stat-macros.h
697
698# Perl -lne code to extract "significant" cpp-defined symbols from a
699# gnulib header file, eliminating a few common false-positives.
700gl_extract_significant_defines_ = \
701 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
702 && $$2 !~ /(?:rpl_|_used_without_)/\
703 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
704 and print $$1
705
706# Create a list of regular expressions matching the names
707# of macros that are guaranteed to be defined by parts of gnulib.
708define def_sym_regex
709 gen_h=$(gl_generated_headers_); \
710 (cd $(gnulib_dir)/lib; \
711 for f in *.in.h $(gl_other_headers_); do \
712 perl -lne '$(gl_extract_significant_defines_)' $$f; \
713 done; \
714 ) | sort -u \
715 | grep -Ev '^ATTRIBUTE_NORETURN' \
716 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
717endef
718
719# Don't define macros that we already get from gnulib header files.
720sc_prohibit_always-defined_macros:
721 @if test -d $(gnulib_dir); then \
722 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
723 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
724 esac; \
725 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
726 && { echo '$(ME): define the above via some gnulib .h file' \
727 1>&2; exit 1; } || :; \
728 fi
729# ==================================================================
730
731# Prohibit checked in backup files.
732sc_prohibit_backup_files:
733 @$(VC_LIST) | grep '~$$' && \
734 { echo '$(ME): found version controlled backup file' 1>&2; \
735 exit 1; } || :
c84bdaf6
LC
736
737# Require the latest GPL.
738sc_GPL_version:
a927b6c1
LC
739 @prohibit='either ''version [^3]' \
740 halt='GPL vN, N!=3' \
741 $(_sc_search_regexp)
c84bdaf6 742
61cd9dc9
LC
743# Require the latest GFDL. Two regexp, since some .texi files end up
744# line wrapping between 'Free Documentation License,' and 'Version'.
745_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
746sc_GFDL_version:
a927b6c1
LC
747 @prohibit='$(_GFDL_regexp)' \
748 halt='GFDL vN, N!=3' \
749 $(_sc_search_regexp)
750
0f00f2c3
LC
751# Don't use Texinfo's @acronym{}.
752# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
753texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
754sc_texinfo_acronym:
755 @prohibit='@acronym\{' \
756 in_vc_files='$(texinfo_suffix_re_)' \
757 halt='found use of Texinfo @acronym{}' \
758 $(_sc_search_regexp)
61cd9dc9 759
c84bdaf6
LC
760cvs_keywords = \
761 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
762
763sc_prohibit_cvs_keyword:
a927b6c1
LC
764 @prohibit='\$$($(cvs_keywords))\$$' \
765 halt='do not use CVS keyword expansion' \
766 $(_sc_search_regexp)
767
768# This Perl code is slightly obfuscated. Not only is each "$" doubled
769# because it's in a Makefile, but the $$c's are comments; we cannot
770# use "#" due to the way the script ends up concatenated onto one line.
771# It would be much more concise, and would produce better output (including
772# counts) if written as:
773# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
774# but that would be far less efficient, reading the entire contents
775# of each file, rather than just the last two bytes of each.
776#
777# This is a perl script that is expected to be the single-quoted argument
778# to a command-line "-le". The remaining arguments are file names.
779# Print the name of each file that ends in two or more newline bytes.
780# Exit nonzero if at least one such file is found, otherwise, exit 0.
781# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
782#
783# Use this if you want to remove trailing empty lines from selected files:
784# perl -pi -0777 -e 's/\n\n+$/\n/' files...
785#
786detect_empty_lines_at_EOF_ = \
787 foreach my $$f (@ARGV) \
788 { \
789 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
790 my $$p = sysseek (F, -2, 2); \
791 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
792 my $$last_two_bytes; \
793 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
794 close F; \
795 $$c = "ignore read failure"; \
796 $$p && $$last_two_bytes eq "\n\n" and (print $$f), $$fail=1; \
797 } \
798 END { exit defined $$fail }
799sc_prohibit_empty_lines_at_EOF:
800 @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
801 || { echo '$(ME): the above files end with empty line(s)' \
802 1>&2; exit 1; } || :; \
c84bdaf6
LC
803
804# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
805# This is a bit of a kludge, since it prevents use of the string
806# even in comments, but for now it does the job with no false positives.
807sc_prohibit_stat_st_blocks:
a927b6c1
LC
808 @prohibit='[.>]st_blocks' \
809 halt='do not use st_blocks; use ST_NBLOCKS' \
810 $(_sc_search_regexp)
c84bdaf6
LC
811
812# Make sure we don't define any S_IS* macros in src/*.c files.
813# They're already defined via gnulib's sys/stat.h replacement.
814sc_prohibit_S_IS_definition:
a927b6c1
LC
815 @prohibit='^ *# *define *S_IS' \
816 halt='do not define S_IS* macros; include <sys/stat.h>' \
817 $(_sc_search_regexp)
818
819_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
820_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
821# Using test's -a and -o operators is not portable.
822# We prefer test over [, since the latter is spelled [[ in configure.ac.
823sc_prohibit_test_minus_ao:
824 @prohibit='(\<test| \[+) .+ -[ao] ' \
825 halt='$(_ptm1); $(_ptm2)' \
826 $(_sc_search_regexp)
c84bdaf6 827
0f00f2c3
LC
828# Avoid a test bashism.
829sc_prohibit_test_double_equal:
830 @prohibit='(\<test| \[+) .+ == ' \
831 containing='#! */bin/[a-z]*sh' \
832 halt='use "test x = x", not "test x =''= x"' \
833 $(_sc_search_regexp)
834
61cd9dc9
LC
835# Each program that uses proper_name_utf8 must link with one of the
836# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
837# The perl -0777 invocation below extracts the possibly-multi-line
838# definition of LDADD from the appropriate Makefile.am and exits 0
839# when it contains "ICONV".
c84bdaf6
LC
840sc_proper_name_utf8_requires_ICONV:
841 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
842 if test "x$$progs" != x; then \
843 fail=0; \
844 for p in $$progs; do \
845 dir=$$(dirname "$$p"); \
61cd9dc9
LC
846 perl -0777 \
847 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
848 $$dir/Makefile.am && continue; \
c84bdaf6
LC
849 base=$$(basename "$$p" .c); \
850 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
851 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
852 done; \
853 test $$fail = 1 && \
854 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
855 exit 1; } || :; \
856 fi
857
858# Warn about "c0nst struct Foo const foo[]",
859# but not about "char const *const foo" or "#define const const".
860sc_redundant_const:
a927b6c1
LC
861 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
862 halt='redundant "const" in declarations' \
863 $(_sc_search_regexp)
c84bdaf6
LC
864
865sc_const_long_option:
866 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
867 | grep -Ev 'const struct option|struct option const' && { \
868 echo 1>&2 '$(ME): add "const" to the above declarations'; \
869 exit 1; } || :
870
871NEWS_hash = \
872 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
873 $(srcdir)/NEWS \
61cd9dc9
LC
874 | perl -0777 -pe \
875 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
876 | md5sum - \
877 | sed 's/ .*//')
878
879# Ensure that we don't accidentally insert an entry into an old NEWS block.
880sc_immutable_NEWS:
881 @if test -f $(srcdir)/NEWS; then \
882 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
883 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
884 fi
885
886# Update the hash stored above. Do this after each release and
887# for any corrections to old entries.
888update-NEWS-hash: NEWS
889 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
890 $(srcdir)/cfg.mk
891
892# Ensure that we use only the standard $(VAR) notation,
893# not @...@ in Makefile.am, now that we can rely on automake
894# to emit a definition for each substituted variable.
895# We use perl rather than "grep -nE ..." to exempt a single
896# use of an @...@-delimited variable name in src/Makefile.am.
61cd9dc9
LC
897# Allow the package to add exceptions via a hook in cfg.mk;
898# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
899# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
900_makefile_at_at_check_exceptions ?=
901sc_makefile_at_at_check:
902 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
c84bdaf6
LC
903 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
904 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
905 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
906
1cd4fffc 907news-check: NEWS
9157d901
LC
908 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
909 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
910 :; \
911 else \
1cd4fffc 912 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
913 exit 1; \
914 fi
915
916sc_makefile_TAB_only_indentation:
a927b6c1
LC
917 @prohibit='^ [ ]{8}' \
918 in_vc_files='akefile|\.mk$$' \
919 halt='found TAB-8-space indentation' \
920 $(_sc_search_regexp)
c84bdaf6
LC
921
922sc_m4_quote_check:
a927b6c1
LC
923 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
924 in_vc_files='(^configure\.ac|\.m4)$$' \
925 halt='quote the first arg to AC_DEF*' \
926 $(_sc_search_regexp)
c84bdaf6
LC
927
928fix_po_file_diag = \
929'you have changed the set of files with translatable diagnostics;\n\
930apply the above patch\n'
931
932# Verify that all source files using _() are listed in po/POTFILES.in.
933po_file = po/POTFILES.in
934sc_po_check:
935 @if test -f $(po_file); then \
936 grep -E -v '^(#|$$)' $(po_file) \
937 | grep -v '^src/false\.c$$' | sort > $@-1; \
938 files=; \
939 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
940 test -r $$file || continue; \
941 case $$file in \
942 *.m4|*.mk) continue ;; \
943 *.?|*.??) ;; \
944 *) continue;; \
945 esac; \
946 case $$file in \
947 *.[ch]) \
948 base=`expr " $$file" : ' \(.*\)\..'`; \
949 { test -f $$base.l || test -f $$base.y; } && continue;; \
950 esac; \
951 files="$$files $$file"; \
952 done; \
953 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
954 | sort -u > $@-2; \
955 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
956 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
957 rm -f $@-1 $@-2; \
958 fi
959
960# Sometimes it is useful to change the PATH environment variable
961# in Makefiles. When doing so, it's better not to use the Unix-centric
962# path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
963msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
964sc_makefile_path_separator_check:
a927b6c1
LC
965 @prohibit='PATH[=].*:' \
966 in_vc_files='akefile|\.mk$$' \
967 halt=$(msg) \
968 $(_sc_search_regexp)
c84bdaf6
LC
969
970# Check that `make alpha' will not fail at the end of the process.
971writable-files:
972 if test -d $(release_archive_dir); then :; else \
973 for file in $(distdir).tar.gz \
974 $(release_archive_dir)/$(distdir).tar.gz; do \
975 test -e $$file || continue; \
976 test -w $$file \
977 || { echo ERROR: $$file is not writable; fail=1; }; \
978 done; \
979 test "$$fail" && exit 1 || : ; \
980 fi
981
2e65b52f 982v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
983sample-test = tests/sample-test
984texi = doc/$(PACKAGE).texi
985# Make sure that the copyright date in $(v_etc_file) is up to date.
986# Do the same for the $(sample-test) and the main doc/.texi file.
987sc_copyright_check:
a927b6c1
LC
988 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
989 in_files=$(v_etc_file) \
990 halt='out of date copyright in $(v_etc_file); update it' \
991 $(_sc_search_regexp)
992 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
993 in_vc_files=$(sample-test) \
994 halt='out of date copyright in $(sample-test); update it' \
995 $(_sc_search_regexp)
996 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
997 in_vc_files=$(texi) \
998 halt='out of date copyright in $(texi); update it' \
999 $(_sc_search_regexp)
1000
1001# If tests/help-version exists and seems to be new enough, assume that its
1002# use of init.sh and path_prepend_ is correct, and ensure that every other
1003# use of init.sh is identical.
1004# This is useful because help-version cross-checks prog --version
1005# with $(VERSION), which verifies that its path_prepend_ invocation
1006# sets PATH correctly. This is an inexpensive way to ensure that
1007# the other init.sh-using tests also get it right.
1008_hv_file ?= $(srcdir)/tests/help-version
1009_hv_regex_weak ?= ^ *\. .*/init\.sh"
1010_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1011sc_cross_check_PATH_usage_in_tests:
1012 @if test -f $(_hv_file); then \
1013 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1014 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1015 exit 0; }; \
1016 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1017 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1018 exit 1; }; \
1019 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1020 grep -LFx "$$good" \
1021 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1022 | grep . && \
1023 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1024 1>&2; exit 1; } || :; \
c84bdaf6
LC
1025 fi
1026
61cd9dc9
LC
1027# #if HAVE_... will evaluate to false for any non numeric string.
1028# That would be flagged by using -Wundef, however gnulib currently
1029# tests many undefined macros, and so we can't enable that option.
1030# So at least preclude common boolean strings as macro values.
1031sc_Wundef_boolean:
a927b6c1
LC
1032 @prohibit='^#define.*(yes|no|true|false)$$' \
1033 in_files='$(CONFIG_INCLUDE)' \
1034 halt='Use 0 or 1 for macro values' \
1035 $(_sc_search_regexp)
61cd9dc9
LC
1036
1037sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1038 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1039 in_files=$$(find $(srcdir) -name Makefile.in) \
0f00f2c3
LC
1040 halt=$$(printf '%s\n' \
1041 'the above files are vulnerable; beware of running' \
1042 ' "make dist*" rules, and upgrade to fixed automake' \
1043 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1044 $(_sc_search_regexp)
61cd9dc9 1045
c84bdaf6
LC
1046vc-diff-check:
1047 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1048 if test -s vc-diffs; then \
1049 cat vc-diffs; \
1050 echo "Some files are locally modified:" 1>&2; \
1051 exit 1; \
1052 else \
1053 rm vc-diffs; \
1054 fi
1055
c84bdaf6
LC
1056rel-files = $(DIST_ARCHIVES)
1057
1058gnulib_dir ?= $(srcdir)/gnulib
1059gnulib-version = $$(cd $(gnulib_dir) && git describe)
1060bootstrap-tools ?= autoconf,automake,gnulib
1061
61cd9dc9
LC
1062# If it's not already specified, derive the GPG key ID from
1063# the signed tag we've just applied to mark this release.
1064gpg_key_ID ?= \
1065 $$(git cat-file tag v$(VERSION) > .ann-sig \
1066 && gpgv .ann-sig - < /dev/null 2>&1 \
1067 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1068
a927b6c1
LC
1069translation_project_ ?= coordinator@translationproject.org
1070announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1071announcement_mail_headers_ ?= \
1072To: info-gnu@gnu.org \
1073Cc: $(announcement_Cc_) \
1074Mail-Followup-To: $(PACKAGE_BUGREPORT)
1075
c84bdaf6
LC
1076announcement: NEWS ChangeLog $(rel-files)
1077 @$(build_aux)/announce-gen \
a927b6c1 1078 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1079 --release-type=$(RELEASE_TYPE) \
1080 --package=$(PACKAGE) \
1081 --prev=$(PREV_VERSION) \
1082 --curr=$(VERSION) \
1083 --gpg-key-id=$(gpg_key_ID) \
61cd9dc9 1084 --news=$(srcdir)/NEWS \
c84bdaf6
LC
1085 --bootstrap-tools=$(bootstrap-tools) \
1086 --gnulib-version=$(gnulib-version) \
1087 --no-print-checksums \
1088 $(addprefix --url-dir=, $(url_dir_list))
1089
1090## ---------------- ##
1091## Updating files. ##
1092## ---------------- ##
1093
1094ftp-gnu = ftp://ftp.gnu.org/gnu
1095www-gnu = http://www.gnu.org
1096
dde9c5a4 1097upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1098emit_upload_commands:
1099 @echo =====================================
1100 @echo =====================================
1101 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1102 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1103 @echo " $(rel-files)"
61cd9dc9 1104 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1105 @echo =====================================
1106 @echo =====================================
1107
c84bdaf6
LC
1108define emit-commit-log
1109 printf '%s\n' 'post-release administrivia' '' \
1110 '* NEWS: Add header line for next release.' \
1111 '* .prev-version: Record previous version.' \
1112 '* cfg.mk (old_NEWS_hash): Auto-update.'
1113endef
1114
1115.PHONY: no-submodule-changes
1116no-submodule-changes:
1117 if test -d $(srcdir)/.git; then \
1118 diff=$$(cd $(srcdir) && git submodule -q foreach \
1119 git diff-index --name-only HEAD) \
1120 || exit 1; \
1121 case $$diff in '') ;; \
1122 *) echo '$(ME): submodule files are locally modified:'; \
1123 echo "$$diff"; exit 1;; esac; \
1124 else \
1125 : ; \
1126 fi
1127
49114fd4
LC
1128submodule-checks ?= no-submodule-changes public-submodule-commit
1129
1130# Ensure that each sub-module commit we're using is public.
1131# Without this, it is too easy to tag and release code that
1132# cannot be built from a fresh clone.
1133.PHONY: public-submodule-commit
1134public-submodule-commit:
1135 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1136 cd $(srcdir) && \
1137 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1138 = '$$(git merge-base origin $$sha1)' \
1139 || { echo '$(ME): found non-public submodule commit' >&2; \
1140 exit 1; }; \
1141 else \
1142 : ; \
1143 fi
1144# This rule has a high enough utility/cost ratio that it should be a
1145# dependent of "check" by default. However, some of us do occasionally
1146# commit a temporary change that deliberately points to a non-public
1147# submodule commit, and want to be able to use rules like "make check".
1148# In that case, run e.g., "make check gl_public_submodule_commit="
1149# to disable this test.
1150gl_public_submodule_commit ?= public-submodule-commit
1151check: $(gl_public_submodule_commit)
1152
c84bdaf6
LC
1153.PHONY: alpha beta stable
1154ALL_RECURSIVE_TARGETS += alpha beta stable
49114fd4 1155alpha beta stable: $(local-check) writable-files $(submodule-checks)
c84bdaf6
LC
1156 test $@ = stable \
1157 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1158 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1159 || :
1160 $(MAKE) vc-diff-check
1cd4fffc 1161 $(MAKE) news-check
c84bdaf6
LC
1162 $(MAKE) distcheck
1163 $(MAKE) dist XZ_OPT=-9ev
1cd4fffc
LC
1164 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1165 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1166
1167# Override this in cfg.mk if you follow different procedures.
1168release-prep-hook ?= release-prep
1169
0f00f2c3 1170gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1171.PHONY: release-prep
1172release-prep:
1173 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1174 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
61cd9dc9 1175 $(MAKE) -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1176 if test -d $(release_archive_dir); then \
1177 ln $(rel-files) $(release_archive_dir); \
1178 chmod a-w $(rel-files); \
1179 fi
c84bdaf6
LC
1180 echo $(VERSION) > $(prev_version_file)
1181 $(MAKE) update-NEWS-hash
0f00f2c3 1182 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
c84bdaf6
LC
1183 $(emit-commit-log) > .ci-msg
1184 $(VC) commit -F .ci-msg -a
61cd9dc9 1185 rm .ci-msg
c84bdaf6 1186
a927b6c1
LC
1187# Override this with e.g., -s $(srcdir)/some_other_name.texi
1188# if the default $(PACKAGE)-derived name doesn't apply.
1189gendocs_options_ ?=
1190
c84bdaf6
LC
1191.PHONY: web-manual
1192web-manual:
1193 @test -z "$(manual_title)" \
1194 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1195 @cd '$(srcdir)/doc'; \
a927b6c1
LC
1196 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1197 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1198 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1199 "$(PACKAGE_NAME) - $(manual_title)"
1200 @echo " *** Upload the doc/manual directory to web-cvs."
1201
1202# Code Coverage
1203
1204init-coverage:
1205 $(MAKE) $(AM_MAKEFLAGS) clean
1206 lcov --directory . --zerocounters
1207
1208COVERAGE_CCOPTS ?= "-g --coverage"
1209COVERAGE_OUT ?= doc/coverage
1210
1211build-coverage:
1212 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1213 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1214 mkdir -p $(COVERAGE_OUT)
1215 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1216 --capture
1217
1218gen-coverage:
1219 genhtml --output-directory $(COVERAGE_OUT) \
1220 $(COVERAGE_OUT)/$(PACKAGE).info \
1221 --highlight --frames --legend \
1222 --title "$(PACKAGE_NAME)"
1223
1224coverage: init-coverage build-coverage gen-coverage
1225
1226# Update gettext files.
1227PACKAGE ?= $(shell basename $(PWD))
1228PO_DOMAIN ?= $(PACKAGE)
1229POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1230PODIR ?= po
1231refresh-po:
1232 rm -f $(PODIR)/*.po && \
1233 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1234 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1235 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1236 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1237 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1238
a927b6c1 1239 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1240INDENT_SOURCES ?= $(C_SOURCES)
1241.PHONY: indent
1242indent:
1243 indent $(INDENT_SOURCES)
a927b6c1 1244 indent $(INDENT_SOURCES)
c84bdaf6
LC
1245
1246# If you want to set UPDATE_COPYRIGHT_* environment variables,
1247# put the assignments in this variable.
1248update-copyright-env ?=
1249
1250# Run this rule once per year (usually early in January)
1251# to update all FSF copyright year lists in your project.
1252# If you have an additional project-specific rule,
1253# add it in cfg.mk along with a line 'update-copyright: prereq'.
1254# By default, exclude all variants of COPYING; you can also
1255# add exemptions (such as ChangeLog..* for rotated change logs)
1256# in the file .x-update-copyright.
1257.PHONY: update-copyright
1258update-copyright:
1259 grep -l -w Copyright \
1260 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1261 | $(update-copyright-env) xargs $(build_aux)/$@